Index: TWiki/UI/Save.pm
===================================================================
--- TWiki/UI/Save.pm	(revision 13172)
+++ TWiki/UI/Save.pm	(working copy)
@@ -43,24 +43,23 @@
 
 # Used by save and preview
 sub buildNewTopic {
-    my( $session, $script ) = @_;
+    my( $script ) = @_;
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-    my $store = $session->{store};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $store = $TWiki::STORE;
 
     unless( scalar($query->param()) ) {
         # insufficient parameters to save
         throw TWiki::OopsException( 'attention',
                                     def => 'bad_script_parameters',
-                                    web => $session->{webName},
-                                    topic => $session->{topicName},
+                                    web => $TWiki::SESSION->{webName},
+                                    topic => $TWiki::SESSION->{topicName},
                                     params => [ $script ]);
     }
 
-    TWiki::UI::checkMirror( $session, $webName, $topic );
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'save' );
+    TWiki::UI::checkWebExists( $webName, $topic, 'save' );
 
     my $topicExists  = $store->topicExists( $webName, $topic );
 
@@ -87,8 +86,8 @@
                                     params => [ $topic ] );
     }
 
-    my $user = $session->{user};
-    TWiki::UI::checkAccess( $session, $webName, $topic,
+    my $user = $TWiki::SESSION->{user};
+    TWiki::UI::checkAccess( $webName, $topic,
                             'CHANGE', $user );
 
     my $saveOpts = {};
@@ -96,7 +95,7 @@
     my $originalrev = $query->param( 'originalrev' ); # rev edit started on
 
     # Populate the new meta data
-    my $newMeta = new TWiki::Meta( $session, $webName, $topic );
+    my $newMeta = new TWiki::Meta( $webName, $topic );
 
     my ( $prevMeta, $prevText );
     my ( $templateText, $templateMeta );
@@ -116,14 +115,14 @@
         }
     } elsif ($templatetopic) {
         ( $templateweb, $templatetopic ) =
-          $session->normalizeWebTopicName( $templateweb, $templatetopic );
+          $TWiki::SESSION->normalizeWebTopicName( $templateweb, $templatetopic );
 
         ( $templateMeta, $templateText ) =
           $store->readTopic( $user, $templateweb,
                              $templatetopic, undef );
         $templateText = '' if $query->param( 'newtopic' ); # created by edit
         $templateText =
-          $session->expandVariablesOnTopicCreation( $templateText );
+          $TWiki::SESSION->expandVariablesOnTopicCreation( $templateText );
         foreach my $k ( keys %$templateMeta ) {
             unless( $k =~ /^_/ || $k eq 'FORM' || $k eq 'TOPICPARENT' ||
                       $k eq 'FIELD' || $k eq 'TOPICMOVED' ) {
@@ -191,12 +190,12 @@
     }
 
     if( $formName ) {
-        $formDef = new TWiki::Form( $session, $webName, $formName );
+        $formDef = new TWiki::Form( $TWiki::SESSION, $webName, $formName );
         unless( $formDef ) {
             throw TWiki::OopsException( 'attention',
                                         def => 'no_form_def',
-                                        web => $session->{webName},
-                                        topic => $session->{topicName},
+                                        web => $TWiki::SESSION->{webName},
+                                        topic => $TWiki::SESSION->{topicName},
                                         params => [ $webName, $formName ] );
         }
         $newMeta->put( 'FORM', { name => $formName });
@@ -222,8 +221,8 @@
             throw TWiki::OopsException(
                 'attention',
                 def=>'mandatory_field',
-                web => $session->{webName},
-                topic => $session->{topicName},
+                web => $TWiki::SESSION->{webName},
+                topic => $TWiki::SESSION->{topicName},
                 params => [ join( ' ', @$missing ) ] );
         }
     }
@@ -253,7 +252,7 @@
                     $pti->{version}, $prevText,
                     $rev, $newText,
                     '.*?\n',
-                    $session );
+                    $TWiki::SESSION );
             } else {
                 # common ancestor; we can 3-way merge
                 my( $ancestorMeta, $ancestorText ) =
@@ -262,7 +261,7 @@
                     $orev, $ancestorText,
                     $rev, $prevText,
                     'new', $newText,
-                    '.*?\n', $session );
+                    '.*?\n', $TWiki::SESSION );
             }
             if( $formDef && $prevMeta ) {
                 $newMeta->merge( $prevMeta, $formDef );
@@ -275,9 +274,7 @@
 }
 
 sub _getRedirectUrl {
-    my $session = shift;
-
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $redirecturl = $query->param( 'redirectto' );
     return '' unless $redirecturl;
     if( $redirecturl =~ /^$TWiki::regex{linkProtocolPattern}\:\/\//o ) {
@@ -289,13 +286,13 @@
         }
     }
     # assuming 'web.topic' or 'topic'
-    my ( $w, $t ) = $session->normalizeWebTopicName( $session->{webName}, $redirecturl );
-    $redirecturl = $session->getScriptUrl( 1, 'view', $w, $t );
+    my ( $w, $t ) = $TWiki::SESSION->normalizeWebTopicName( $TWiki::SESSION->{webName}, $redirecturl );
+    $redirecturl = $TWiki::SESSION->getScriptUrl( 1, 'view', $w, $t );
 }
 
 =pod
 
----++ StaticMethod save($session)
+---++ StaticMethod save()
 
 Command handler for =save= command.
 This method is designed to be
@@ -309,14 +306,12 @@
 =cut
 
 sub save {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $web = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $store = $TWiki::STORE;
+    my $user = $TWiki::SESSION->{user};
 
-    my $query = $session->{cgiQuery};
-    my $web = $session->{webName};
-    my $topic = $session->{topicName};
-    my $store = $session->{store};
-    my $user = $session->{user};
-
     # Do not remove, keep as undocumented feature for compatibility with
     # TWiki 4.0.x: Allow for dynamic topic creation by replacing strings
     # of at least 10 x's XXXXXX with a next-in-sequence number.
@@ -330,7 +325,7 @@
 			$topic =~ s/X{10}X*/$n/e;
 			$n++;
 		} while( $store->topicExists( $web, $topic ));
-        $session->{topicName} = $topic;
+        $TWiki::SESSION->{topicName} = $topic;
     }
 
     # Allow for more flexible topic creation with sortable names and
@@ -361,10 +356,10 @@
             # first auto-inc topic
             $topic =~ s/AUTOINC[0-9]+/$start/;
         }
-        $session->{topicName} = $topic;
+        $TWiki::SESSION->{topicName} = $topic;
     }
 
-    my $redirecturl = _getRedirectUrl( $session );
+    my $redirecturl = _getRedirectUrl();
     my $saveaction = '';
     foreach my $action qw( save checkpoint quietsave cancel preview
                            addform replaceform delRev repRev ) {
@@ -378,7 +373,7 @@
     # for compatibility with old templates.
     if( !$saveaction && $query->param( 'action' )) {
         $saveaction = lc($query->param( 'action' ));
-        $session->writeWarning(<<WARN);
+        $TWiki::SESSION->writeWarning(<<WARN);
 Use of deprecated "action" parameter to "save". Correct your templates!
 WARN
 
@@ -401,19 +396,19 @@
                                $query->param( 'topicparent' ),
                                $TWiki::cfg{HomeTopicName} ) {
                 ( $w, $t ) =
-                  $session->normalizeWebTopicName( $web, $test );
+                  $TWiki::SESSION->normalizeWebTopicName( $web, $test );
                 last if( $store->topicExists( $w, $t ));
             }
-            $viewURL = $session->getScriptUrl( 1, 'view', $w, $t );
+            $viewURL = $TWiki::SESSION->getScriptUrl( 1, 'view', $w, $t );
         }
-        $session->redirect( $viewURL );
+        $TWiki::SESSION->redirect( $viewURL );
 
         return;
     }
 
     if( $saveaction eq 'preview' ) {
         require TWiki::UI::Preview;
-        TWiki::UI::Preview::preview( $session );
+        TWiki::UI::Preview::preview( $TWiki::SESSION );
         return;
     }
 
@@ -426,15 +421,14 @@
           $saveaction eq 'replaceform' ||
             $saveaction eq 'preview' && $query->param( 'submitChangeForm' )) {
         require TWiki::UI::ChangeForm;
-        $session->writeCompletePage
-          ( TWiki::UI::ChangeForm::generate( $session, $web,
-                                             $topic, $editaction ) );
+        $TWiki::SESSION->writeCompletePage
+          ( TWiki::UI::ChangeForm::generate( $web, $topic, $editaction ) );
         return;
     }
 
     if( $saveaction eq 'checkpoint' ) {
         $query->param( -name=>'dontnotify', -value=>'checked' );
-        my $editURL = $session->getScriptUrl( 1, $edit, $web, $topic );
+        my $editURL = $TWiki::SESSION->getScriptUrl( 1, $edit, $web, $topic );
         $redirecturl = $editURL.'?t='.time();
         $redirecturl .= '&redirectto='.$query->param( 'redirectto' )
           if $query->param( 'redirectto' );
@@ -468,14 +462,14 @@
     }
 
     my $saveCmd = $query->param( 'cmd' ) || 0;
-    if ( $saveCmd && ! $session->{user}->isAdmin()) {
+    if ( $saveCmd && ! $TWiki::SESSION->{user}->isAdmin()) {
         throw TWiki::OopsException( 'accessdenied', def => 'only_group',
                                     web => $web, topic => $topic,
                                     params => $TWiki::cfg{UsersWebName}.
                                       '.'.$TWiki::cfg{SuperAdminGroup} );
     }
 
-    $redirecturl ||= $session->getScriptUrl( 1, 'view', $web, $topic );
+    $redirecturl ||= $TWiki::SESSION->getScriptUrl( 1, 'view', $web, $topic );
 
     if( $saveCmd eq 'delRev' ) {
         # delete top revision
@@ -489,7 +483,7 @@
                                         params => shift->{-text} );
         };
 
-        $session->redirect( $redirecturl );
+        $TWiki::SESSION->redirect( $redirecturl );
         return;
     }
 
@@ -498,7 +492,7 @@
         # make it look as much like the original as possible. The query
         # text is expected to contain %META as well as text.
         my $textQueryParam = $query->param( 'text' );
-        my $meta = new TWiki::Meta( $session, $web, $topic );
+        my $meta = new TWiki::Meta( $web, $topic );
         $store->extractMetaData( $meta, \$textQueryParam );
         my $saveOpts = {
             timetravel => 1,
@@ -515,15 +509,15 @@
                                         params => shift->{-text} );
         };
 
-        $session->redirect( $redirecturl );
+        $TWiki::SESSION->redirect( $redirecturl );
         return;
     }
 
     my( $newMeta, $newText, $saveOpts, $merged ) =
-      TWiki::UI::Save::buildNewTopic($session, 'save');
+      TWiki::UI::Save::buildNewTopic($TWiki::SESSION, 'save');
 
     if( $saveaction =~ /^(save|checkpoint)$/ ) {
-        $session->{plugins}->afterEditHandler( $newText, $topic, $web, $newMeta );
+        $TWiki::PLUGINS->afterEditHandler( $newText, $topic, $web, $newMeta );
     }
 
     try {
@@ -550,7 +544,7 @@
                                     params => $merged );
     }
 
-    $session->redirect( $redirecturl );
+    $TWiki::SESSION->redirect( $redirecturl );
 }
 
 1;
Index: TWiki/UI/Oops.pm
===================================================================
--- TWiki/UI/Oops.pm	(revision 13172)
+++ TWiki/UI/Oops.pm	(working copy)
@@ -33,7 +33,7 @@
 
 =pod
 
----++ StaticMethod oops_cgi($session)
+---++ StaticMethod oops_cgi()
 
 =oops= command handler.
 This method is designed to be invoked via the =TWiki::UI::run= method.
@@ -46,17 +46,16 @@
 =cut
 
 sub oops_cgi {
-    my $session = shift;
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
-    my $query = $session->{cgiQuery};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
 
-    oops( $session, $web, $topic, $query, 0 );
+    oops( $web, $topic, $query, 0 );
 }
 
 =pod
 
----++ StaticMethod oops($session, $web, $topic, $query, $keep)
+---++ StaticMethod oops( $web, $topic, $query, $keep)
 
 The body of an oops script call, abstracted out so it can be called for
 the case where an oops is required, but all the parameters in the query
@@ -69,7 +68,7 @@
 =cut
 
 sub oops {
-    my( $session, $web, $topic, $query, $keep ) = @_;
+    my( $web, $topic, $query, $keep ) = @_;
 
     my $tmplName;
     my $def;
@@ -101,9 +100,9 @@
     # Do not pass on the template parameter otherwise continuation won't work
     $query->delete( 'template' );
 
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
 
-    my $tmplData = $session->{templates}->readTemplate( $tmplName, $skin );
+    my $tmplData = $TWiki::TEMPLATES->readTemplate( $tmplName, $skin );
 
     if( ! $tmplData ) {
         $tmplData = CGI::start_html()
@@ -114,22 +113,22 @@
     } else {
         if( defined $def ) {
             # if a def is specified, instantiate that def
-            my $blah = $session->{templates}->expandTemplate( $def );
+            my $blah = $TWiki::TEMPLATES->expandTemplate( $def );
             $tmplData =~ s/%INSTANTIATE%/$blah/;
         }
-        $tmplData = $session->handleCommonTags( $tmplData, $web, $topic );
+        $tmplData = $TWiki::SESSION->handleCommonTags( $tmplData, $web, $topic );
         $n = 1;
         foreach my $param ( @params ) {
             $tmplData =~ s/%PARAM$n%/$param/g;
             $n++;
         }
         ASSERT( $tmplData !~ /%PARAM\d+%/ ) if DEBUG;
-        $tmplData = $session->handleCommonTags( $tmplData, $web, $topic );
-        $tmplData = $session->{renderer}->getRenderedVersion( $tmplData, $web,
+        $tmplData = $TWiki::SESSION->handleCommonTags( $tmplData, $web, $topic );
+        $tmplData = $TWiki::RENDER->getRenderedVersion( $tmplData, $web,
                                                               $topic );
     }
 
-    $session->writeCompletePage( $tmplData );
+    $TWiki::SESSION->writeCompletePage( $tmplData );
 }
 
 1;
Index: TWiki/UI/Preview.pm
===================================================================
--- TWiki/UI/Preview.pm	(revision 13172)
+++ TWiki/UI/Preview.pm	(working copy)
@@ -28,15 +28,13 @@
 use TWiki::OopsException;
 
 sub preview {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $web = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $user = $TWiki::SESSION->{user};
 
-    my $query = $session->{cgiQuery};
-    my $web = $session->{webName};
-    my $topic = $session->{topicName};
-    my $user = $session->{user};
-
     my( $meta, $text, $saveOpts, $merged ) =
-      TWiki::UI::Save::buildNewTopic($session, 'preview');
+      TWiki::UI::Save::buildNewTopic('preview');
 
     # Note: param(formtemplate) has already been decoded by buildNewTopic
     # so the $meta entry reflects if it was used.
@@ -44,21 +42,21 @@
     my $form = $meta->get('FORM') || '';
     if( $form ) {
         $form = $form->{name}; # used later on as well
-        my $formDef = new TWiki::Form( $session, $web, $form );
+        my $formDef = new TWiki::Form( $web, $form );
         unless( $formDef ) {
             throw TWiki::OopsException( 'attention',
                                         def => 'no_form_def',
-                                        web => $session->{webName},
-                                        topic => $session->{topicName},
+                                        web => $TWiki::SESSION->{webName},
+                                        topic => $TWiki::SESSION->{topicName},
                                         params => [ $web, $form ] );
         }
         $formFields = $formDef->renderHidden( $meta, 0 );
     }
 
-    $session->{plugins}->afterEditHandler( $text, $topic, $web );
+    $TWiki::PLUGINS->afterEditHandler( $text, $topic, $web );
 
-    my $skin = $session->getSkin();
-    my $tmpl = $session->{templates}->readTemplate( 'preview', $skin );
+    my $skin = $TWiki::SESSION->getSkin();
+    my $tmpl = $TWiki::TEMPLATES->readTemplate( 'preview', $skin );
     if( $saveOpts->{minor} ) {
         $tmpl =~ s/%DONTNOTIFYCHECKBOX%/checked="checked"/go;
     } else {
@@ -82,11 +80,11 @@
     $parent ||= '';
     $tmpl =~ s/%TOPICPARENT%/$parent/g;
 
-    $session->enterContext( 'can_render_meta', $meta );
+    $TWiki::SESSION->enterContext( 'can_render_meta', $meta );
 
     my $dispText = $text;
-    $dispText = $session->handleCommonTags( $dispText, $web, $topic, $meta );
-    $dispText = $session->{renderer}->getRenderedVersion( $dispText, $web, $topic );
+    $dispText = $TWiki::SESSION->handleCommonTags( $dispText, $web, $topic, $meta );
+    $dispText = $TWiki::RENDER->getRenderedVersion( $dispText, $web, $topic );
 
     # Disable links and inputs in the text
     $dispText =~ s#<a\s[^>]*>(.*?)</a>#<span class="twikiEmulatedLink">$1</span>#gis;
@@ -94,8 +92,8 @@
     $dispText =~ s(</?form(|\s.*?)>)()gis;
     $dispText =~ s/(<[^>]*\bon[A-Za-z]+=)('[^']*'|"[^"]*")/$1''/gis;
 
-    $tmpl = $session->handleCommonTags( $tmpl, $web, $topic, $meta );
-    $tmpl = $session->{renderer}->getRenderedVersion( $tmpl, $web, $topic );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $web, $topic, $meta );
+    $tmpl = $TWiki::RENDER->getRenderedVersion( $tmpl, $web, $topic );
     $tmpl =~ s/%TEXT%/$dispText/go;
     $tmpl =~ s/%FORMFIELDS%/$formFields/go;
 
@@ -106,7 +104,7 @@
 
     $tmpl =~ s/<\/?(nop|noautolink)\/?>//gis;
 
-    $session->writeCompletePage( $tmpl );
+    $TWiki::SESSION->writeCompletePage( $tmpl );
 }
 
 1;
